/*
 * Created by wangshengye on 2020/05/07.
 *
 */

#ifndef ELF_SIGN_H
#define ELF_SIGN_H
#ifdef __cplusplus
extern "C" {
#endif
#include <stdbool.h>
#include <elf_parse.h>

typedef struct {
    int auth_result;//验证结果
    int sec_type;//证书安全类型
    unsigned char *serialnum;//证书序列号
    unsigned int serlen;//证书序列号长度
    unsigned char *finger;//证书指纹(SM3)
    unsigned int fingerlenth;//证书指纹长度
} AU_get;

typedef struct sof_ctx_t sof_ctx_t;

/*
 * @function:     elf文件签名函数
 * @input param:  elfPath elf文件路径
 * @              certPath 证书路径
 * @              pkey_file 私钥
 * @
 * @return        true 签名成功，false 签名失败
 */
bool elf_signature(const char *elfPath, const char *certPath, const char *pkey_file);

/*
 * @function:     elf文件签名验证函数
 * @input param:  elfPath elf文件路径
 * @return        true 验签成功，false 验签失败
 */
bool elf_verify(const char *elfPath);

bool elf_deletesign(const char *elfPath);

bool ELF_signature(const char *elfPath, const char *certPath, sof_ctx_t *ctx);

bool signtoELF64(Elf64 *elf64, const char *certPath, sof_ctx_t *ctx);

bool ELF_verify(sof_ctx_t *ctx, const char *elfPath);

bool ELF_SecType_permissions(const char *elfPath);

int Get_elfcertmessage(char *elfPath,AU_get *AUresult,int kysec_authenticated);

int getElfIssuerST(const char *file,char *IssuerST);

int getElfIssuerOU(const char *file,char *IssuerST);

int getElfSubjectOU(const char *file,char *IssuerST);

int getElfSubjectO(const char *file,char *IssuerST);

int getElfSubjectCN(const char *file,char *IssuerST);

int getElfCertSecType(const char *file,char *IssuerST);
#ifdef __cplusplus
}
#endif

#endif //ELF_SIGN_
